/**
 */
package de.mdelab.mlstorypatterns;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Abstract Story Pattern Link</b></em>'. <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Superclass of all links in a StoryPattern.
 * 
 * Source and target of a link must be contained in the same story pattern link 
 * the link itself or in the containing pattern.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.mdelab.mlstorypatterns.AbstractStoryPatternLink#getSource <em>Source</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.AbstractStoryPatternLink#getTarget <em>Target</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.AbstractStoryPatternLink#getStoryPattern <em>Story Pattern</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getAbstractStoryPatternLink()
 * @model abstract="true"
 * @generated
 */
public interface AbstractStoryPatternLink extends StoryPatternElement {
	/**
	 * Returns the value of the '<em><b>Source</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternObject#getOutgoingLinks <em>Outgoing Links</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Source</em>' reference isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Source</em>' reference.
	 * @see #setSource(AbstractStoryPatternObject)
	 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getAbstractStoryPatternLink_Source()
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternObject#getOutgoingLinks
	 * @model opposite="outgoingLinks" resolveProxies="false" required="true"
	 * @generated
	 */
	AbstractStoryPatternObject getSource();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlstorypatterns.AbstractStoryPatternLink#getSource
	 * <em>Source</em>}' reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @param value
	 *            the new value of the '<em>Source</em>' reference.
	 * @see #getSource()
	 * @generated
	 */
	void setSource(AbstractStoryPatternObject value);

	/**
	 * Returns the value of the '<em><b>Target</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternObject#getIncomingLinks <em>Incoming Links</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Target</em>' reference isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Target</em>' reference.
	 * @see #setTarget(AbstractStoryPatternObject)
	 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getAbstractStoryPatternLink_Target()
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternObject#getIncomingLinks
	 * @model opposite="incomingLinks" resolveProxies="false" required="true"
	 * @generated
	 */
	AbstractStoryPatternObject getTarget();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlstorypatterns.AbstractStoryPatternLink#getTarget
	 * <em>Target</em>}' reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @param value
	 *            the new value of the '<em>Target</em>' reference.
	 * @see #getTarget()
	 * @generated
	 */
	void setTarget(AbstractStoryPatternObject value);

	/**
	 * Returns the value of the '<em><b>Story Pattern</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link de.mdelab.mlstorypatterns.StoryPattern#getStoryPatternLinks <em>Story Pattern Links</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Story Pattern</em>' container reference isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Story Pattern</em>' container reference.
	 * @see #setStoryPattern(StoryPattern)
	 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getAbstractStoryPatternLink_StoryPattern()
	 * @see de.mdelab.mlstorypatterns.StoryPattern#getStoryPatternLinks
	 * @model opposite="storyPatternLinks" resolveProxies="false" required="true" transient="false"
	 * @generated
	 */
	StoryPattern getStoryPattern();

	/**
	 * Sets the value of the '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternLink#getStoryPattern <em>Story Pattern</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Story Pattern</em>' container reference.
	 * @see #getStoryPattern()
	 * @generated
	 */
	void setStoryPattern(StoryPattern value);

} // AbstractStoryPatternLink
