/**
 */
package de.mdelab.mlstorypatterns;

import org.eclipse.emf.common.util.EList;

import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlcore.MLTypedElement;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Abstract Story Pattern Object</b></em>'. <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Superclass of all objects in a StoryPattern.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.mdelab.mlstorypatterns.AbstractStoryPatternObject#getOutgoingLinks <em>Outgoing Links</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.AbstractStoryPatternObject#getIncomingLinks <em>Incoming Links</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.AbstractStoryPatternObject#getStoryPattern <em>Story Pattern</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getAbstractStoryPatternObject()
 * @model abstract="true"
 * @generated
 */
public interface AbstractStoryPatternObject extends StoryPatternElement,
		MLNamedElement, MLTypedElement {
	/**
	 * Returns the value of the '<em><b>Outgoing Links</b></em>' reference list.
	 * The list contents are of type {@link de.mdelab.mlstorypatterns.AbstractStoryPatternLink}.
	 * It is bidirectional and its opposite is '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternLink#getSource <em>Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Outgoing Links</em>' reference list isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Outgoing Links</em>' reference list.
	 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getAbstractStoryPatternObject_OutgoingLinks()
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternLink#getSource
	 * @model opposite="source" resolveProxies="false" ordered="false"
	 * @generated
	 */
	EList<AbstractStoryPatternLink> getOutgoingLinks();

	/**
	 * Returns the value of the '<em><b>Incoming Links</b></em>' reference list.
	 * The list contents are of type {@link de.mdelab.mlstorypatterns.AbstractStoryPatternLink}.
	 * It is bidirectional and its opposite is '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternLink#getTarget <em>Target</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Incoming Links</em>' reference list isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Incoming Links</em>' reference list.
	 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getAbstractStoryPatternObject_IncomingLinks()
	 * @see de.mdelab.mlstorypatterns.AbstractStoryPatternLink#getTarget
	 * @model opposite="target" resolveProxies="false" ordered="false"
	 * @generated
	 */
	EList<AbstractStoryPatternLink> getIncomingLinks();

	/**
	 * Returns the value of the '<em><b>Story Pattern</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link de.mdelab.mlstorypatterns.StoryPattern#getStoryPatternObjects <em>Story Pattern Objects</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Story Pattern</em>' container reference isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Story Pattern</em>' container reference.
	 * @see #setStoryPattern(StoryPattern)
	 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getAbstractStoryPatternObject_StoryPattern()
	 * @see de.mdelab.mlstorypatterns.StoryPattern#getStoryPatternObjects
	 * @model opposite="storyPatternObjects" resolveProxies="false" required="true" transient="false"
	 * @generated
	 */
	StoryPattern getStoryPattern();

	/**
	 * Sets the value of the '{@link de.mdelab.mlstorypatterns.AbstractStoryPatternObject#getStoryPattern <em>Story Pattern</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Story Pattern</em>' container reference.
	 * @see #getStoryPattern()
	 * @generated
	 */
	void setStoryPattern(StoryPattern value);

} // AbstractStoryPatternObject
