/**
 */
package de.mdelab.mlstorypatterns;

import org.eclipse.emf.ecore.EStructuralFeature;

import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MLElementWithUUID;
import de.mdelab.mlexpressions.MLExpression;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Attribute Assignment</b></em>'. <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Attribute assignments specify attribute values to set when the StoryPattern is applied. Attribute assignments are evaluated after matching the pattern but before applying it.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.mdelab.mlstorypatterns.AttributeAssignment#getStoryPatternObject <em>Story Pattern Object</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.AttributeAssignment#getAssignmentExpression <em>Assignment Expression</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.AttributeAssignment#getFeature <em>Feature</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getAttributeAssignment()
 * @model
 * @generated
 */
public interface AttributeAssignment extends MLElementWithUUID,
		MLAnnotatedElement {
	/**
	 * Returns the value of the '<em><b>Story Pattern Object</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link de.mdelab.mlstorypatterns.StoryPatternObject#getAttributeAssignments <em>Attribute Assignments</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Story Pattern Object</em>' container reference
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Story Pattern Object</em>' container reference.
	 * @see #setStoryPatternObject(StoryPatternObject)
	 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getAttributeAssignment_StoryPatternObject()
	 * @see de.mdelab.mlstorypatterns.StoryPatternObject#getAttributeAssignments
	 * @model opposite="attributeAssignments" resolveProxies="false" required="true" transient="false"
	 * @generated
	 */
	StoryPatternObject getStoryPatternObject();

	/**
	 * Sets the value of the '{@link de.mdelab.mlstorypatterns.AttributeAssignment#getStoryPatternObject <em>Story Pattern Object</em>}' container reference.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Story Pattern Object</em>' container reference.
	 * @see #getStoryPatternObject()
	 * @generated
	 */
	void setStoryPatternObject(StoryPatternObject value);

	/**
	 * Returns the value of the '<em><b>Assignment Expression</b></em>'
	 * containment reference. <!-- begin-user-doc --> <!-- end-user-doc --> <!--
	 * begin-model-doc --> This expression computes the new attribute value.
	 * <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Assignment Expression</em>' containment
	 *         reference.
	 * @see #setAssignmentExpression(MLExpression)
	 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getAttributeAssignment_AssignmentExpression()
	 * @model containment="true" required="true"
	 * @generated
	 */
	MLExpression getAssignmentExpression();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlstorypatterns.AttributeAssignment#getAssignmentExpression
	 * <em>Assignment Expression</em>}' containment reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Assignment Expression</em>'
	 *            containment reference.
	 * @see #getAssignmentExpression()
	 * @generated
	 */
	void setAssignmentExpression(MLExpression value);

	/**
	 * Returns the value of the '<em><b>Feature</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc --> The
	 * feature of the object to set to the new value. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Feature</em>' reference.
	 * @see #setFeature(EStructuralFeature)
	 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getAttributeAssignment_Feature()
	 * @model required="true"
	 * @generated
	 */
	EStructuralFeature getFeature();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlstorypatterns.AttributeAssignment#getFeature
	 * <em>Feature</em>}' reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @param value
	 *            the new value of the '<em>Feature</em>' reference.
	 * @see #getFeature()
	 * @generated
	 */
	void setFeature(EStructuralFeature value);

} // AttributeAssignment
