/**
 */
package de.mdelab.mlstorypatterns;

import org.eclipse.emf.ecore.EStructuralFeature;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Map Entry Link</b></em>'. <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A MapEntryLink is matched to MapEntries. It is a link between a source object that contains a map and a key and a value object that represent a pair of key and value in that map.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.mdelab.mlstorypatterns.MapEntryLink#getFeature <em>Feature</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.MapEntryLink#getValueTarget <em>Value Target</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getMapEntryLink()
 * @model
 * @generated
 */
public interface MapEntryLink extends AbstractStoryPatternLink {
	/**
	 * Returns the value of the '<em><b>Feature</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc --> The map
	 * feature of the source model. Its type must be java.util.Map$Entry, it
	 * must be many-valued, and it must be a containment. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Feature</em>' reference.
	 * @see #setFeature(EStructuralFeature)
	 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getMapEntryLink_Feature()
	 * @model required="true"
	 * @generated
	 */
	EStructuralFeature getFeature();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlstorypatterns.MapEntryLink#getFeature
	 * <em>Feature</em>}' reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @param value
	 *            the new value of the '<em>Feature</em>' reference.
	 * @see #getFeature()
	 * @generated
	 */
	void setFeature(EStructuralFeature value);

	/**
	 * Returns the value of the '<em><b>Value Target</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc --> This
	 * object is matched to the value of the map entry. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Value Target</em>' reference.
	 * @see #setValueTarget(AbstractStoryPatternObject)
	 * @see de.mdelab.mlstorypatterns.MlstorypatternsPackage#getMapEntryLink_ValueTarget()
	 * @model
	 * @generated
	 */
	AbstractStoryPatternObject getValueTarget();

	/**
	 * Sets the value of the '{@link de.mdelab.mlstorypatterns.MapEntryLink#getValueTarget <em>Value Target</em>}' reference.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @param value the new value of the '<em>Value Target</em>' reference.
	 * @see #getValueTarget()
	 * @generated
	 */
	void setValueTarget(AbstractStoryPatternObject value);

} // MapEntryLink
