package de.mdelab.mlstorypatterns.diagram.custom.edit.parts;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.mlstorypatterns.LinkOrderConstraint;
import de.mdelab.mlstorypatterns.diagram.edit.parts.LinkOrderConstraintEditPart;

public class CustomLinkOrderConstraintLabelEditPart extends LinkOrderConstraintEditPart
{

	public CustomLinkOrderConstraintLabelEditPart(View view)
	{
		super(view);
	}

	@Override
	protected void handleNotificationEvent(Notification event)
	{
		if (event.getNotifier() instanceof LinkOrderConstraint)
		{
			adaptLabelText();
		}

		super.handleNotificationEvent(event);
	}

	@Override
	protected void refreshVisuals()
	{
		super.refreshVisuals();
		adaptLabelText();
	}

	protected void adaptLabelText()
	{
		setForegroundColor(ColorConstants.gray);
		//setFontColor(ColorConstants.gray);

		LinkOrderConstraint linkOderingConstraint = (LinkOrderConstraint) ((View) getModel()).getElement();
		switch (linkOderingConstraint.getConstraintType())
		{
			case DIRECT_SUCCESSOR:
			{
				//((WrappingLabel) getFigure()).setText("{next}");
				break;
			}
			case ANY_SUCCESSOR:
			{
				//((WrappingLabel) getFigure()).setText("{...}");
				break;
			}
			default:
			{
				throw new UnsupportedOperationException();
			}
		}
	}
}
