/**
 */
package de.mdelab.mlstorypatterns.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;

import de.mdelab.mlstorypatterns.AbstractStoryPatternLink;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.StoryPattern;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Abstract Story Pattern Link</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.AbstractStoryPatternLinkImpl#getSource <em>Source</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.AbstractStoryPatternLinkImpl#getTarget <em>Target</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.AbstractStoryPatternLinkImpl#getStoryPattern <em>Story Pattern</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class AbstractStoryPatternLinkImpl extends
		StoryPatternElementImpl implements AbstractStoryPatternLink {
	/**
	 * The cached value of the '{@link #getSource() <em>Source</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getSource()
	 * @generated
	 * @ordered
	 */
	protected AbstractStoryPatternObject source;

	/**
	 * The cached value of the '{@link #getTarget() <em>Target</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getTarget()
	 * @generated
	 * @ordered
	 */
	protected AbstractStoryPatternObject target;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected AbstractStoryPatternLinkImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlstorypatternsPackage.Literals.ABSTRACT_STORY_PATTERN_LINK;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public AbstractStoryPatternObject getSource() {
		return source;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetSource(
			AbstractStoryPatternObject newSource, NotificationChain msgs) {
		AbstractStoryPatternObject oldSource = source;
		source = newSource;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this,
					Notification.SET,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__SOURCE,
					oldSource, newSource);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setSource(AbstractStoryPatternObject newSource) {
		if (newSource != source) {
			NotificationChain msgs = null;
			if (source != null)
				msgs = ((InternalEObject) source)
						.eInverseRemove(
								this,
								MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__OUTGOING_LINKS,
								AbstractStoryPatternObject.class, msgs);
			if (newSource != null)
				msgs = ((InternalEObject) newSource)
						.eInverseAdd(
								this,
								MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__OUTGOING_LINKS,
								AbstractStoryPatternObject.class, msgs);
			msgs = basicSetSource(newSource, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__SOURCE,
					newSource, newSource));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public AbstractStoryPatternObject getTarget() {
		return target;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetTarget(
			AbstractStoryPatternObject newTarget, NotificationChain msgs) {
		AbstractStoryPatternObject oldTarget = target;
		target = newTarget;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this,
					Notification.SET,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__TARGET,
					oldTarget, newTarget);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setTarget(AbstractStoryPatternObject newTarget) {
		if (newTarget != target) {
			NotificationChain msgs = null;
			if (target != null)
				msgs = ((InternalEObject) target)
						.eInverseRemove(
								this,
								MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__INCOMING_LINKS,
								AbstractStoryPatternObject.class, msgs);
			if (newTarget != null)
				msgs = ((InternalEObject) newTarget)
						.eInverseAdd(
								this,
								MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__INCOMING_LINKS,
								AbstractStoryPatternObject.class, msgs);
			msgs = basicSetTarget(newTarget, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__TARGET,
					newTarget, newTarget));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public StoryPattern getStoryPattern() {
		if (eContainerFeatureID() != MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN)
			return null;
		return (StoryPattern) eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStoryPattern(StoryPattern newStoryPattern,
			NotificationChain msgs) {
		msgs = eBasicSetContainer(
				(InternalEObject) newStoryPattern,
				MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN,
				msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setStoryPattern(StoryPattern newStoryPattern) {
		if (newStoryPattern != eInternalContainer()
				|| (eContainerFeatureID() != MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN && newStoryPattern != null)) {
			if (EcoreUtil.isAncestor(this, newStoryPattern))
				throw new IllegalArgumentException(
						"Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newStoryPattern != null)
				msgs = ((InternalEObject) newStoryPattern)
						.eInverseAdd(
								this,
								MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_LINKS,
								StoryPattern.class, msgs);
			msgs = basicSetStoryPattern(newStoryPattern, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(
					this,
					Notification.SET,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN,
					newStoryPattern, newStoryPattern));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__SOURCE:
			if (source != null)
				msgs = ((InternalEObject) source)
						.eInverseRemove(
								this,
								MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__OUTGOING_LINKS,
								AbstractStoryPatternObject.class, msgs);
			return basicSetSource((AbstractStoryPatternObject) otherEnd, msgs);
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__TARGET:
			if (target != null)
				msgs = ((InternalEObject) target)
						.eInverseRemove(
								this,
								MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__INCOMING_LINKS,
								AbstractStoryPatternObject.class, msgs);
			return basicSetTarget((AbstractStoryPatternObject) otherEnd, msgs);
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN:
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			return basicSetStoryPattern((StoryPattern) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__SOURCE:
			return basicSetSource(null, msgs);
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__TARGET:
			return basicSetTarget(null, msgs);
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN:
			return basicSetStoryPattern(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(
			NotificationChain msgs) {
		switch (eContainerFeatureID()) {
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN:
			return eInternalContainer().eInverseRemove(this,
					MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_LINKS,
					StoryPattern.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__SOURCE:
			return getSource();
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__TARGET:
			return getTarget();
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN:
			return getStoryPattern();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__SOURCE:
			setSource((AbstractStoryPatternObject) newValue);
			return;
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__TARGET:
			setTarget((AbstractStoryPatternObject) newValue);
			return;
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN:
			setStoryPattern((StoryPattern) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__SOURCE:
			setSource((AbstractStoryPatternObject) null);
			return;
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__TARGET:
			setTarget((AbstractStoryPatternObject) null);
			return;
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN:
			setStoryPattern((StoryPattern) null);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__SOURCE:
			return source != null;
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__TARGET:
			return target != null;
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__STORY_PATTERN:
			return getStoryPattern() != null;
		}
		return super.eIsSet(featureID);
	}

} // AbstractStoryPatternLinkImpl
