/**
 */
package de.mdelab.mlstorypatterns.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlcore.MLTypedElement;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlstorypatterns.AbstractStoryPatternLink;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.StoryPattern;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Abstract Story Pattern Object</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.AbstractStoryPatternObjectImpl#getName <em>Name</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.AbstractStoryPatternObjectImpl#getType <em>Type</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.AbstractStoryPatternObjectImpl#getOutgoingLinks <em>Outgoing Links</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.AbstractStoryPatternObjectImpl#getIncomingLinks <em>Incoming Links</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.AbstractStoryPatternObjectImpl#getStoryPattern <em>Story Pattern</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class AbstractStoryPatternObjectImpl extends
		StoryPatternElementImpl implements AbstractStoryPatternObject {
	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getType() <em>Type</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected EClassifier type;

	/**
	 * The cached value of the '{@link #getOutgoingLinks() <em>Outgoing Links</em>}' reference list.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getOutgoingLinks()
	 * @generated
	 * @ordered
	 */
	protected EList<AbstractStoryPatternLink> outgoingLinks;

	/**
	 * The cached value of the '{@link #getIncomingLinks() <em>Incoming Links</em>}' reference list.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getIncomingLinks()
	 * @generated
	 * @ordered
	 */
	protected EList<AbstractStoryPatternLink> incomingLinks;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected AbstractStoryPatternObjectImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlstorypatternsPackage.Literals.ABSTRACT_STORY_PATTERN_OBJECT;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__NAME,
					oldName, name));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClassifier getType() {
		if (type != null && type.eIsProxy()) {
			InternalEObject oldType = (InternalEObject) type;
			type = (EClassifier) eResolveProxy(oldType);
			if (type != oldType) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(
							this,
							Notification.RESOLVE,
							MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__TYPE,
							oldType, type));
			}
		}
		return type;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EClassifier basicGetType() {
		return type;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setType(EClassifier newType) {
		EClassifier oldType = type;
		type = newType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__TYPE,
					oldType, type));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<AbstractStoryPatternLink> getOutgoingLinks() {
		if (outgoingLinks == null) {
			outgoingLinks = new EObjectWithInverseEList<AbstractStoryPatternLink>(
					AbstractStoryPatternLink.class,
					this,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__OUTGOING_LINKS,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__SOURCE);
		}
		return outgoingLinks;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<AbstractStoryPatternLink> getIncomingLinks() {
		if (incomingLinks == null) {
			incomingLinks = new EObjectWithInverseEList<AbstractStoryPatternLink>(
					AbstractStoryPatternLink.class,
					this,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__INCOMING_LINKS,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_LINK__TARGET);
		}
		return incomingLinks;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public StoryPattern getStoryPattern() {
		if (eContainerFeatureID() != MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN)
			return null;
		return (StoryPattern) eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStoryPattern(StoryPattern newStoryPattern,
			NotificationChain msgs) {
		msgs = eBasicSetContainer(
				(InternalEObject) newStoryPattern,
				MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN,
				msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setStoryPattern(StoryPattern newStoryPattern) {
		if (newStoryPattern != eInternalContainer()
				|| (eContainerFeatureID() != MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN && newStoryPattern != null)) {
			if (EcoreUtil.isAncestor(this, newStoryPattern))
				throw new IllegalArgumentException(
						"Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newStoryPattern != null)
				msgs = ((InternalEObject) newStoryPattern)
						.eInverseAdd(
								this,
								MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_OBJECTS,
								StoryPattern.class, msgs);
			msgs = basicSetStoryPattern(newStoryPattern, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(
					this,
					Notification.SET,
					MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN,
					newStoryPattern, newStoryPattern));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__OUTGOING_LINKS:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getOutgoingLinks())
					.basicAdd(otherEnd, msgs);
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__INCOMING_LINKS:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getIncomingLinks())
					.basicAdd(otherEnd, msgs);
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN:
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			return basicSetStoryPattern((StoryPattern) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__OUTGOING_LINKS:
			return ((InternalEList<?>) getOutgoingLinks()).basicRemove(
					otherEnd, msgs);
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__INCOMING_LINKS:
			return ((InternalEList<?>) getIncomingLinks()).basicRemove(
					otherEnd, msgs);
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN:
			return basicSetStoryPattern(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(
			NotificationChain msgs) {
		switch (eContainerFeatureID()) {
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN:
			return eInternalContainer()
					.eInverseRemove(
							this,
							MlstorypatternsPackage.STORY_PATTERN__STORY_PATTERN_OBJECTS,
							StoryPattern.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__NAME:
			return getName();
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__TYPE:
			if (resolve)
				return getType();
			return basicGetType();
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__OUTGOING_LINKS:
			return getOutgoingLinks();
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__INCOMING_LINKS:
			return getIncomingLinks();
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN:
			return getStoryPattern();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__NAME:
			setName((String) newValue);
			return;
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__TYPE:
			setType((EClassifier) newValue);
			return;
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__OUTGOING_LINKS:
			getOutgoingLinks().clear();
			getOutgoingLinks().addAll(
					(Collection<? extends AbstractStoryPatternLink>) newValue);
			return;
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__INCOMING_LINKS:
			getIncomingLinks().clear();
			getIncomingLinks().addAll(
					(Collection<? extends AbstractStoryPatternLink>) newValue);
			return;
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN:
			setStoryPattern((StoryPattern) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__NAME:
			setName(NAME_EDEFAULT);
			return;
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__TYPE:
			setType((EClassifier) null);
			return;
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__OUTGOING_LINKS:
			getOutgoingLinks().clear();
			return;
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__INCOMING_LINKS:
			getIncomingLinks().clear();
			return;
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN:
			setStoryPattern((StoryPattern) null);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT
					.equals(name);
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__TYPE:
			return type != null;
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__OUTGOING_LINKS:
			return outgoingLinks != null && !outgoingLinks.isEmpty();
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__INCOMING_LINKS:
			return incomingLinks != null && !incomingLinks.isEmpty();
		case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__STORY_PATTERN:
			return getStoryPattern() != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == MLNamedElement.class) {
			switch (derivedFeatureID) {
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__NAME:
				return MlcorePackage.ML_NAMED_ELEMENT__NAME;
			default:
				return -1;
			}
		}
		if (baseClass == MLTypedElement.class) {
			switch (derivedFeatureID) {
			case MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__TYPE:
				return MlcorePackage.ML_TYPED_ELEMENT__TYPE;
			default:
				return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == MLNamedElement.class) {
			switch (baseFeatureID) {
			case MlcorePackage.ML_NAMED_ELEMENT__NAME:
				return MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__NAME;
			default:
				return -1;
			}
		}
		if (baseClass == MLTypedElement.class) {
			switch (baseFeatureID) {
			case MlcorePackage.ML_TYPED_ELEMENT__TYPE:
				return MlstorypatternsPackage.ABSTRACT_STORY_PATTERN_OBJECT__TYPE;
			default:
				return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

} // AbstractStoryPatternObjectImpl
