/**
 */
package de.mdelab.mlstorypatterns.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import de.mdelab.mlannotations.MLAnnotation;
import de.mdelab.mlannotations.MlannotationsPackage;
import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlcore.impl.MLElementWithUUIDImpl;
import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlstorypatterns.AttributeAssignment;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.StoryPatternObject;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Attribute Assignment</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.AttributeAssignmentImpl#getAnnotations <em>Annotations</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.AttributeAssignmentImpl#getStoryPatternObject <em>Story Pattern Object</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.AttributeAssignmentImpl#getAssignmentExpression <em>Assignment Expression</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.AttributeAssignmentImpl#getFeature <em>Feature</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class AttributeAssignmentImpl extends MLElementWithUUIDImpl implements
		AttributeAssignment {
	/**
	 * The cached value of the '{@link #getAnnotations() <em>Annotations</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getAnnotations()
	 * @generated
	 * @ordered
	 */
	protected EList<MLAnnotation> annotations;

	/**
	 * The cached value of the '{@link #getAssignmentExpression()
	 * <em>Assignment Expression</em>}' containment reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getAssignmentExpression()
	 * @generated
	 * @ordered
	 */
	protected MLExpression assignmentExpression;

	/**
	 * The cached value of the '{@link #getFeature() <em>Feature</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getFeature()
	 * @generated
	 * @ordered
	 */
	protected EStructuralFeature feature;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected AttributeAssignmentImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlstorypatternsPackage.Literals.ATTRIBUTE_ASSIGNMENT;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<MLAnnotation> getAnnotations() {
		if (annotations == null) {
			annotations = new EObjectContainmentWithInverseEList<MLAnnotation>(
					MLAnnotation.class, this,
					MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ANNOTATIONS,
					MlannotationsPackage.ML_ANNOTATION__ELEMENT);
		}
		return annotations;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public StoryPatternObject getStoryPatternObject() {
		if (eContainerFeatureID() != MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT)
			return null;
		return (StoryPatternObject) eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStoryPatternObject(
			StoryPatternObject newStoryPatternObject, NotificationChain msgs) {
		msgs = eBasicSetContainer(
				(InternalEObject) newStoryPatternObject,
				MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT,
				msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setStoryPatternObject(StoryPatternObject newStoryPatternObject) {
		if (newStoryPatternObject != eInternalContainer()
				|| (eContainerFeatureID() != MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT && newStoryPatternObject != null)) {
			if (EcoreUtil.isAncestor(this, newStoryPatternObject))
				throw new IllegalArgumentException(
						"Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newStoryPatternObject != null)
				msgs = ((InternalEObject) newStoryPatternObject)
						.eInverseAdd(
								this,
								MlstorypatternsPackage.STORY_PATTERN_OBJECT__ATTRIBUTE_ASSIGNMENTS,
								StoryPatternObject.class, msgs);
			msgs = basicSetStoryPatternObject(newStoryPatternObject, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(
					this,
					Notification.SET,
					MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT,
					newStoryPatternObject, newStoryPatternObject));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public MLExpression getAssignmentExpression() {
		return assignmentExpression;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetAssignmentExpression(
			MLExpression newAssignmentExpression, NotificationChain msgs) {
		MLExpression oldAssignmentExpression = assignmentExpression;
		assignmentExpression = newAssignmentExpression;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(
					this,
					Notification.SET,
					MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ASSIGNMENT_EXPRESSION,
					oldAssignmentExpression, newAssignmentExpression);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setAssignmentExpression(MLExpression newAssignmentExpression) {
		if (newAssignmentExpression != assignmentExpression) {
			NotificationChain msgs = null;
			if (assignmentExpression != null)
				msgs = ((InternalEObject) assignmentExpression)
						.eInverseRemove(
								this,
								EOPPOSITE_FEATURE_BASE
										- MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ASSIGNMENT_EXPRESSION,
								null, msgs);
			if (newAssignmentExpression != null)
				msgs = ((InternalEObject) newAssignmentExpression)
						.eInverseAdd(
								this,
								EOPPOSITE_FEATURE_BASE
										- MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ASSIGNMENT_EXPRESSION,
								null, msgs);
			msgs = basicSetAssignmentExpression(newAssignmentExpression, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(
					this,
					Notification.SET,
					MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ASSIGNMENT_EXPRESSION,
					newAssignmentExpression, newAssignmentExpression));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EStructuralFeature getFeature() {
		if (feature != null && feature.eIsProxy()) {
			InternalEObject oldFeature = (InternalEObject) feature;
			feature = (EStructuralFeature) eResolveProxy(oldFeature);
			if (feature != oldFeature) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(
							this,
							Notification.RESOLVE,
							MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__FEATURE,
							oldFeature, feature));
			}
		}
		return feature;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EStructuralFeature basicGetFeature() {
		return feature;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setFeature(EStructuralFeature newFeature) {
		EStructuralFeature oldFeature = feature;
		feature = newFeature;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__FEATURE,
					oldFeature, feature));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ANNOTATIONS:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getAnnotations())
					.basicAdd(otherEnd, msgs);
		case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT:
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			return basicSetStoryPatternObject((StoryPatternObject) otherEnd,
					msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ANNOTATIONS:
			return ((InternalEList<?>) getAnnotations()).basicRemove(otherEnd,
					msgs);
		case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT:
			return basicSetStoryPatternObject(null, msgs);
		case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ASSIGNMENT_EXPRESSION:
			return basicSetAssignmentExpression(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(
			NotificationChain msgs) {
		switch (eContainerFeatureID()) {
		case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT:
			return eInternalContainer()
					.eInverseRemove(
							this,
							MlstorypatternsPackage.STORY_PATTERN_OBJECT__ATTRIBUTE_ASSIGNMENTS,
							StoryPatternObject.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ANNOTATIONS:
			return getAnnotations();
		case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT:
			return getStoryPatternObject();
		case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ASSIGNMENT_EXPRESSION:
			return getAssignmentExpression();
		case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__FEATURE:
			if (resolve)
				return getFeature();
			return basicGetFeature();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ANNOTATIONS:
			getAnnotations().clear();
			getAnnotations().addAll(
					(Collection<? extends MLAnnotation>) newValue);
			return;
		case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT:
			setStoryPatternObject((StoryPatternObject) newValue);
			return;
		case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ASSIGNMENT_EXPRESSION:
			setAssignmentExpression((MLExpression) newValue);
			return;
		case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__FEATURE:
			setFeature((EStructuralFeature) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ANNOTATIONS:
			getAnnotations().clear();
			return;
		case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT:
			setStoryPatternObject((StoryPatternObject) null);
			return;
		case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ASSIGNMENT_EXPRESSION:
			setAssignmentExpression((MLExpression) null);
			return;
		case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__FEATURE:
			setFeature((EStructuralFeature) null);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ANNOTATIONS:
			return annotations != null && !annotations.isEmpty();
		case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT:
			return getStoryPatternObject() != null;
		case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ASSIGNMENT_EXPRESSION:
			return assignmentExpression != null;
		case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__FEATURE:
			return feature != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (derivedFeatureID) {
			case MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ANNOTATIONS:
				return MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS;
			default:
				return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (baseFeatureID) {
			case MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS:
				return MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__ANNOTATIONS;
			default:
				return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

} // AttributeAssignmentImpl
