/**
 */
package de.mdelab.mlstorypatterns.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import de.mdelab.mlannotations.MLAnnotation;
import de.mdelab.mlannotations.MlannotationsPackage;
import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlcore.impl.MLElementWithUUIDImpl;
import de.mdelab.mlstorypatterns.LinkOrderConstraint;
import de.mdelab.mlstorypatterns.LinkOrderConstraintEnum;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.mlstorypatterns.StoryPatternLink;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Link Order Constraint</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.LinkOrderConstraintImpl#getAnnotations <em>Annotations</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.LinkOrderConstraintImpl#getConstraintType <em>Constraint Type</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.LinkOrderConstraintImpl#getPredecessorLink <em>Predecessor Link</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.LinkOrderConstraintImpl#getSuccessorLink <em>Successor Link</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.LinkOrderConstraintImpl#getStoryPattern <em>Story Pattern</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class LinkOrderConstraintImpl extends MLElementWithUUIDImpl implements
		LinkOrderConstraint {
	/**
	 * The cached value of the '{@link #getAnnotations() <em>Annotations</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getAnnotations()
	 * @generated
	 * @ordered
	 */
	protected EList<MLAnnotation> annotations;

	/**
	 * The default value of the '{@link #getConstraintType() <em>Constraint Type</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getConstraintType()
	 * @generated
	 * @ordered
	 */
	protected static final LinkOrderConstraintEnum CONSTRAINT_TYPE_EDEFAULT = LinkOrderConstraintEnum.ANY_SUCCESSOR;

	/**
	 * The cached value of the '{@link #getConstraintType() <em>Constraint Type</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getConstraintType()
	 * @generated
	 * @ordered
	 */
	protected LinkOrderConstraintEnum constraintType = CONSTRAINT_TYPE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getPredecessorLink() <em>Predecessor Link</em>}' reference.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getPredecessorLink()
	 * @generated
	 * @ordered
	 */
	protected StoryPatternLink predecessorLink;

	/**
	 * The cached value of the '{@link #getSuccessorLink() <em>Successor Link</em>}' reference.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getSuccessorLink()
	 * @generated
	 * @ordered
	 */
	protected StoryPatternLink successorLink;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected LinkOrderConstraintImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlstorypatternsPackage.Literals.LINK_ORDER_CONSTRAINT;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<MLAnnotation> getAnnotations() {
		if (annotations == null) {
			annotations = new EObjectContainmentWithInverseEList<MLAnnotation>(
					MLAnnotation.class, this,
					MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__ANNOTATIONS,
					MlannotationsPackage.ML_ANNOTATION__ELEMENT);
		}
		return annotations;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public LinkOrderConstraintEnum getConstraintType() {
		return constraintType;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setConstraintType(LinkOrderConstraintEnum newConstraintType) {
		LinkOrderConstraintEnum oldConstraintType = constraintType;
		constraintType = newConstraintType == null ? CONSTRAINT_TYPE_EDEFAULT
				: newConstraintType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(
					this,
					Notification.SET,
					MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__CONSTRAINT_TYPE,
					oldConstraintType, constraintType));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public StoryPatternLink getPredecessorLink() {
		return predecessorLink;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetPredecessorLink(
			StoryPatternLink newPredecessorLink, NotificationChain msgs) {
		StoryPatternLink oldPredecessorLink = predecessorLink;
		predecessorLink = newPredecessorLink;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(
					this,
					Notification.SET,
					MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__PREDECESSOR_LINK,
					oldPredecessorLink, newPredecessorLink);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setPredecessorLink(StoryPatternLink newPredecessorLink) {
		if (newPredecessorLink != predecessorLink) {
			NotificationChain msgs = null;
			if (predecessorLink != null)
				msgs = ((InternalEObject) predecessorLink)
						.eInverseRemove(
								this,
								MlstorypatternsPackage.STORY_PATTERN_LINK__OUTGOING_LINK_ORDER_CONSTRAINTS,
								StoryPatternLink.class, msgs);
			if (newPredecessorLink != null)
				msgs = ((InternalEObject) newPredecessorLink)
						.eInverseAdd(
								this,
								MlstorypatternsPackage.STORY_PATTERN_LINK__OUTGOING_LINK_ORDER_CONSTRAINTS,
								StoryPatternLink.class, msgs);
			msgs = basicSetPredecessorLink(newPredecessorLink, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(
					this,
					Notification.SET,
					MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__PREDECESSOR_LINK,
					newPredecessorLink, newPredecessorLink));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public StoryPatternLink getSuccessorLink() {
		return successorLink;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetSuccessorLink(
			StoryPatternLink newSuccessorLink, NotificationChain msgs) {
		StoryPatternLink oldSuccessorLink = successorLink;
		successorLink = newSuccessorLink;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(
					this,
					Notification.SET,
					MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__SUCCESSOR_LINK,
					oldSuccessorLink, newSuccessorLink);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setSuccessorLink(StoryPatternLink newSuccessorLink) {
		if (newSuccessorLink != successorLink) {
			NotificationChain msgs = null;
			if (successorLink != null)
				msgs = ((InternalEObject) successorLink)
						.eInverseRemove(
								this,
								MlstorypatternsPackage.STORY_PATTERN_LINK__INCOMING_LINK_ORDER_CONSTRAINTS,
								StoryPatternLink.class, msgs);
			if (newSuccessorLink != null)
				msgs = ((InternalEObject) newSuccessorLink)
						.eInverseAdd(
								this,
								MlstorypatternsPackage.STORY_PATTERN_LINK__INCOMING_LINK_ORDER_CONSTRAINTS,
								StoryPatternLink.class, msgs);
			msgs = basicSetSuccessorLink(newSuccessorLink, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(
					this,
					Notification.SET,
					MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__SUCCESSOR_LINK,
					newSuccessorLink, newSuccessorLink));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public StoryPattern getStoryPattern() {
		if (eContainerFeatureID() != MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__STORY_PATTERN)
			return null;
		return (StoryPattern) eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStoryPattern(StoryPattern newStoryPattern,
			NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newStoryPattern,
				MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__STORY_PATTERN,
				msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setStoryPattern(StoryPattern newStoryPattern) {
		if (newStoryPattern != eInternalContainer()
				|| (eContainerFeatureID() != MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__STORY_PATTERN && newStoryPattern != null)) {
			if (EcoreUtil.isAncestor(this, newStoryPattern))
				throw new IllegalArgumentException(
						"Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newStoryPattern != null)
				msgs = ((InternalEObject) newStoryPattern)
						.eInverseAdd(
								this,
								MlstorypatternsPackage.STORY_PATTERN__LINK_ORDER_CONSTRAINTS,
								StoryPattern.class, msgs);
			msgs = basicSetStoryPattern(newStoryPattern, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(
					this,
					Notification.SET,
					MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__STORY_PATTERN,
					newStoryPattern, newStoryPattern));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__ANNOTATIONS:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getAnnotations())
					.basicAdd(otherEnd, msgs);
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__PREDECESSOR_LINK:
			if (predecessorLink != null)
				msgs = ((InternalEObject) predecessorLink)
						.eInverseRemove(
								this,
								MlstorypatternsPackage.STORY_PATTERN_LINK__OUTGOING_LINK_ORDER_CONSTRAINTS,
								StoryPatternLink.class, msgs);
			return basicSetPredecessorLink((StoryPatternLink) otherEnd, msgs);
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__SUCCESSOR_LINK:
			if (successorLink != null)
				msgs = ((InternalEObject) successorLink)
						.eInverseRemove(
								this,
								MlstorypatternsPackage.STORY_PATTERN_LINK__INCOMING_LINK_ORDER_CONSTRAINTS,
								StoryPatternLink.class, msgs);
			return basicSetSuccessorLink((StoryPatternLink) otherEnd, msgs);
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__STORY_PATTERN:
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			return basicSetStoryPattern((StoryPattern) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__ANNOTATIONS:
			return ((InternalEList<?>) getAnnotations()).basicRemove(otherEnd,
					msgs);
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__PREDECESSOR_LINK:
			return basicSetPredecessorLink(null, msgs);
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__SUCCESSOR_LINK:
			return basicSetSuccessorLink(null, msgs);
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__STORY_PATTERN:
			return basicSetStoryPattern(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(
			NotificationChain msgs) {
		switch (eContainerFeatureID()) {
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__STORY_PATTERN:
			return eInternalContainer()
					.eInverseRemove(
							this,
							MlstorypatternsPackage.STORY_PATTERN__LINK_ORDER_CONSTRAINTS,
							StoryPattern.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__ANNOTATIONS:
			return getAnnotations();
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__CONSTRAINT_TYPE:
			return getConstraintType();
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__PREDECESSOR_LINK:
			return getPredecessorLink();
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__SUCCESSOR_LINK:
			return getSuccessorLink();
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__STORY_PATTERN:
			return getStoryPattern();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__ANNOTATIONS:
			getAnnotations().clear();
			getAnnotations().addAll(
					(Collection<? extends MLAnnotation>) newValue);
			return;
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__CONSTRAINT_TYPE:
			setConstraintType((LinkOrderConstraintEnum) newValue);
			return;
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__PREDECESSOR_LINK:
			setPredecessorLink((StoryPatternLink) newValue);
			return;
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__SUCCESSOR_LINK:
			setSuccessorLink((StoryPatternLink) newValue);
			return;
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__STORY_PATTERN:
			setStoryPattern((StoryPattern) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__ANNOTATIONS:
			getAnnotations().clear();
			return;
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__CONSTRAINT_TYPE:
			setConstraintType(CONSTRAINT_TYPE_EDEFAULT);
			return;
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__PREDECESSOR_LINK:
			setPredecessorLink((StoryPatternLink) null);
			return;
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__SUCCESSOR_LINK:
			setSuccessorLink((StoryPatternLink) null);
			return;
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__STORY_PATTERN:
			setStoryPattern((StoryPattern) null);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__ANNOTATIONS:
			return annotations != null && !annotations.isEmpty();
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__CONSTRAINT_TYPE:
			return constraintType != CONSTRAINT_TYPE_EDEFAULT;
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__PREDECESSOR_LINK:
			return predecessorLink != null;
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__SUCCESSOR_LINK:
			return successorLink != null;
		case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__STORY_PATTERN:
			return getStoryPattern() != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (derivedFeatureID) {
			case MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__ANNOTATIONS:
				return MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS;
			default:
				return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (baseFeatureID) {
			case MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS:
				return MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__ANNOTATIONS;
			default:
				return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (constraintType: ");
		result.append(constraintType);
		result.append(')');
		return result.toString();
	}

} // LinkOrderConstraintImpl
