/**
 */
package de.mdelab.mlstorypatterns.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

import de.mdelab.mlstorypatterns.LinkOrderConstraint;
import de.mdelab.mlstorypatterns.LinkPositionConstraintEnum;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.StoryPatternLink;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Story Pattern Link</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternLinkImpl#getFeature <em>Feature</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternLinkImpl#getLinkPositionConstraint <em>Link Position Constraint</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternLinkImpl#getOutgoingLinkOrderConstraints <em>Outgoing Link Order Constraints</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternLinkImpl#getIncomingLinkOrderConstraints <em>Incoming Link Order Constraints</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class StoryPatternLinkImpl extends AbstractStoryPatternLinkImpl
		implements StoryPatternLink {
	/**
	 * The cached value of the '{@link #getFeature() <em>Feature</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getFeature()
	 * @generated
	 * @ordered
	 */
	protected EStructuralFeature feature;

	/**
	 * The default value of the '{@link #getLinkPositionConstraint() <em>Link Position Constraint</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLinkPositionConstraint()
	 * @generated
	 * @ordered
	 */
	protected static final LinkPositionConstraintEnum LINK_POSITION_CONSTRAINT_EDEFAULT = LinkPositionConstraintEnum.UNCONSTRAINED;

	/**
	 * The cached value of the '{@link #getLinkPositionConstraint() <em>Link Position Constraint</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLinkPositionConstraint()
	 * @generated
	 * @ordered
	 */
	protected LinkPositionConstraintEnum linkPositionConstraint = LINK_POSITION_CONSTRAINT_EDEFAULT;

	/**
	 * The cached value of the '{@link #getOutgoingLinkOrderConstraints()
	 * <em>Outgoing Link Order Constraints</em>}' reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getOutgoingLinkOrderConstraints()
	 * @generated
	 * @ordered
	 */
	protected EList<LinkOrderConstraint> outgoingLinkOrderConstraints;

	/**
	 * The cached value of the '{@link #getIncomingLinkOrderConstraints()
	 * <em>Incoming Link Order Constraints</em>}' reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getIncomingLinkOrderConstraints()
	 * @generated
	 * @ordered
	 */
	protected EList<LinkOrderConstraint> incomingLinkOrderConstraints;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected StoryPatternLinkImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlstorypatternsPackage.Literals.STORY_PATTERN_LINK;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EStructuralFeature getFeature() {
		if (feature != null && feature.eIsProxy()) {
			InternalEObject oldFeature = (InternalEObject) feature;
			feature = (EStructuralFeature) eResolveProxy(oldFeature);
			if (feature != oldFeature) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE,
							MlstorypatternsPackage.STORY_PATTERN_LINK__FEATURE,
							oldFeature, feature));
			}
		}
		return feature;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EStructuralFeature basicGetFeature() {
		return feature;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setFeature(EStructuralFeature newFeature) {
		EStructuralFeature oldFeature = feature;
		feature = newFeature;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.STORY_PATTERN_LINK__FEATURE,
					oldFeature, feature));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public LinkPositionConstraintEnum getLinkPositionConstraint() {
		return linkPositionConstraint;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setLinkPositionConstraint(
			LinkPositionConstraintEnum newLinkPositionConstraint) {
		LinkPositionConstraintEnum oldLinkPositionConstraint = linkPositionConstraint;
		linkPositionConstraint = newLinkPositionConstraint == null ? LINK_POSITION_CONSTRAINT_EDEFAULT
				: newLinkPositionConstraint;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(
					this,
					Notification.SET,
					MlstorypatternsPackage.STORY_PATTERN_LINK__LINK_POSITION_CONSTRAINT,
					oldLinkPositionConstraint, linkPositionConstraint));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<LinkOrderConstraint> getOutgoingLinkOrderConstraints() {
		if (outgoingLinkOrderConstraints == null) {
			outgoingLinkOrderConstraints = new EObjectWithInverseEList<LinkOrderConstraint>(
					LinkOrderConstraint.class,
					this,
					MlstorypatternsPackage.STORY_PATTERN_LINK__OUTGOING_LINK_ORDER_CONSTRAINTS,
					MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__PREDECESSOR_LINK);
		}
		return outgoingLinkOrderConstraints;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<LinkOrderConstraint> getIncomingLinkOrderConstraints() {
		if (incomingLinkOrderConstraints == null) {
			incomingLinkOrderConstraints = new EObjectWithInverseEList<LinkOrderConstraint>(
					LinkOrderConstraint.class,
					this,
					MlstorypatternsPackage.STORY_PATTERN_LINK__INCOMING_LINK_ORDER_CONSTRAINTS,
					MlstorypatternsPackage.LINK_ORDER_CONSTRAINT__SUCCESSOR_LINK);
		}
		return incomingLinkOrderConstraints;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlstorypatternsPackage.STORY_PATTERN_LINK__OUTGOING_LINK_ORDER_CONSTRAINTS:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getOutgoingLinkOrderConstraints())
					.basicAdd(otherEnd, msgs);
		case MlstorypatternsPackage.STORY_PATTERN_LINK__INCOMING_LINK_ORDER_CONSTRAINTS:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getIncomingLinkOrderConstraints())
					.basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlstorypatternsPackage.STORY_PATTERN_LINK__OUTGOING_LINK_ORDER_CONSTRAINTS:
			return ((InternalEList<?>) getOutgoingLinkOrderConstraints())
					.basicRemove(otherEnd, msgs);
		case MlstorypatternsPackage.STORY_PATTERN_LINK__INCOMING_LINK_ORDER_CONSTRAINTS:
			return ((InternalEList<?>) getIncomingLinkOrderConstraints())
					.basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case MlstorypatternsPackage.STORY_PATTERN_LINK__FEATURE:
			if (resolve)
				return getFeature();
			return basicGetFeature();
		case MlstorypatternsPackage.STORY_PATTERN_LINK__LINK_POSITION_CONSTRAINT:
			return getLinkPositionConstraint();
		case MlstorypatternsPackage.STORY_PATTERN_LINK__OUTGOING_LINK_ORDER_CONSTRAINTS:
			return getOutgoingLinkOrderConstraints();
		case MlstorypatternsPackage.STORY_PATTERN_LINK__INCOMING_LINK_ORDER_CONSTRAINTS:
			return getIncomingLinkOrderConstraints();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case MlstorypatternsPackage.STORY_PATTERN_LINK__FEATURE:
			setFeature((EStructuralFeature) newValue);
			return;
		case MlstorypatternsPackage.STORY_PATTERN_LINK__LINK_POSITION_CONSTRAINT:
			setLinkPositionConstraint((LinkPositionConstraintEnum) newValue);
			return;
		case MlstorypatternsPackage.STORY_PATTERN_LINK__OUTGOING_LINK_ORDER_CONSTRAINTS:
			getOutgoingLinkOrderConstraints().clear();
			getOutgoingLinkOrderConstraints().addAll(
					(Collection<? extends LinkOrderConstraint>) newValue);
			return;
		case MlstorypatternsPackage.STORY_PATTERN_LINK__INCOMING_LINK_ORDER_CONSTRAINTS:
			getIncomingLinkOrderConstraints().clear();
			getIncomingLinkOrderConstraints().addAll(
					(Collection<? extends LinkOrderConstraint>) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case MlstorypatternsPackage.STORY_PATTERN_LINK__FEATURE:
			setFeature((EStructuralFeature) null);
			return;
		case MlstorypatternsPackage.STORY_PATTERN_LINK__LINK_POSITION_CONSTRAINT:
			setLinkPositionConstraint(LINK_POSITION_CONSTRAINT_EDEFAULT);
			return;
		case MlstorypatternsPackage.STORY_PATTERN_LINK__OUTGOING_LINK_ORDER_CONSTRAINTS:
			getOutgoingLinkOrderConstraints().clear();
			return;
		case MlstorypatternsPackage.STORY_PATTERN_LINK__INCOMING_LINK_ORDER_CONSTRAINTS:
			getIncomingLinkOrderConstraints().clear();
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case MlstorypatternsPackage.STORY_PATTERN_LINK__FEATURE:
			return feature != null;
		case MlstorypatternsPackage.STORY_PATTERN_LINK__LINK_POSITION_CONSTRAINT:
			return linkPositionConstraint != LINK_POSITION_CONSTRAINT_EDEFAULT;
		case MlstorypatternsPackage.STORY_PATTERN_LINK__OUTGOING_LINK_ORDER_CONSTRAINTS:
			return outgoingLinkOrderConstraints != null
					&& !outgoingLinkOrderConstraints.isEmpty();
		case MlstorypatternsPackage.STORY_PATTERN_LINK__INCOMING_LINK_ORDER_CONSTRAINTS:
			return incomingLinkOrderConstraints != null
					&& !incomingLinkOrderConstraints.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (linkPositionConstraint: ");
		result.append(linkPositionConstraint);
		result.append(')');
		return result.toString();
	}

} // StoryPatternLinkImpl
