/**
 */
package de.mdelab.mlstorypatterns.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlstorypatterns.AttributeAssignment;
import de.mdelab.mlstorypatterns.BindingTypeEnum;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.StoryPatternObject;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Story Pattern Object</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternObjectImpl#getBindingType <em>Binding Type</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternObjectImpl#getConstraints <em>Constraints</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternObjectImpl#getAssignmentExpression <em>Assignment Expression</em>}</li>
 *   <li>{@link de.mdelab.mlstorypatterns.impl.StoryPatternObjectImpl#getAttributeAssignments <em>Attribute Assignments</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class StoryPatternObjectImpl extends AbstractStoryPatternObjectImpl
		implements StoryPatternObject {
	/**
	 * The default value of the '{@link #getBindingType() <em>Binding Type</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getBindingType()
	 * @generated
	 * @ordered
	 */
	protected static final BindingTypeEnum BINDING_TYPE_EDEFAULT = BindingTypeEnum.UNBOUND;

	/**
	 * The cached value of the '{@link #getBindingType() <em>Binding Type</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getBindingType()
	 * @generated
	 * @ordered
	 */
	protected BindingTypeEnum bindingType = BINDING_TYPE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getConstraints() <em>Constraints</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getConstraints()
	 * @generated
	 * @ordered
	 */
	protected EList<MLExpression> constraints;

	/**
	 * The cached value of the '{@link #getAssignmentExpression()
	 * <em>Assignment Expression</em>}' containment reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getAssignmentExpression()
	 * @generated
	 * @ordered
	 */
	protected MLExpression assignmentExpression;

	/**
	 * The cached value of the '{@link #getAttributeAssignments()
	 * <em>Attribute Assignments</em>}' containment reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getAttributeAssignments()
	 * @generated
	 * @ordered
	 */
	protected EList<AttributeAssignment> attributeAssignments;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected StoryPatternObjectImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlstorypatternsPackage.Literals.STORY_PATTERN_OBJECT;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public BindingTypeEnum getBindingType() {
		return bindingType;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setBindingType(BindingTypeEnum newBindingType) {
		BindingTypeEnum oldBindingType = bindingType;
		bindingType = newBindingType == null ? BINDING_TYPE_EDEFAULT
				: newBindingType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlstorypatternsPackage.STORY_PATTERN_OBJECT__BINDING_TYPE,
					oldBindingType, bindingType));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<MLExpression> getConstraints() {
		if (constraints == null) {
			constraints = new EObjectContainmentEList<MLExpression>(
					MLExpression.class, this,
					MlstorypatternsPackage.STORY_PATTERN_OBJECT__CONSTRAINTS);
		}
		return constraints;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public MLExpression getAssignmentExpression() {
		return assignmentExpression;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetAssignmentExpression(
			MLExpression newAssignmentExpression, NotificationChain msgs) {
		MLExpression oldAssignmentExpression = assignmentExpression;
		assignmentExpression = newAssignmentExpression;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(
					this,
					Notification.SET,
					MlstorypatternsPackage.STORY_PATTERN_OBJECT__ASSIGNMENT_EXPRESSION,
					oldAssignmentExpression, newAssignmentExpression);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setAssignmentExpression(MLExpression newAssignmentExpression) {
		if (newAssignmentExpression != assignmentExpression) {
			NotificationChain msgs = null;
			if (assignmentExpression != null)
				msgs = ((InternalEObject) assignmentExpression)
						.eInverseRemove(
								this,
								EOPPOSITE_FEATURE_BASE
										- MlstorypatternsPackage.STORY_PATTERN_OBJECT__ASSIGNMENT_EXPRESSION,
								null, msgs);
			if (newAssignmentExpression != null)
				msgs = ((InternalEObject) newAssignmentExpression)
						.eInverseAdd(
								this,
								EOPPOSITE_FEATURE_BASE
										- MlstorypatternsPackage.STORY_PATTERN_OBJECT__ASSIGNMENT_EXPRESSION,
								null, msgs);
			msgs = basicSetAssignmentExpression(newAssignmentExpression, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(
					this,
					Notification.SET,
					MlstorypatternsPackage.STORY_PATTERN_OBJECT__ASSIGNMENT_EXPRESSION,
					newAssignmentExpression, newAssignmentExpression));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<AttributeAssignment> getAttributeAssignments() {
		if (attributeAssignments == null) {
			attributeAssignments = new EObjectContainmentWithInverseEList<AttributeAssignment>(
					AttributeAssignment.class,
					this,
					MlstorypatternsPackage.STORY_PATTERN_OBJECT__ATTRIBUTE_ASSIGNMENTS,
					MlstorypatternsPackage.ATTRIBUTE_ASSIGNMENT__STORY_PATTERN_OBJECT);
		}
		return attributeAssignments;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlstorypatternsPackage.STORY_PATTERN_OBJECT__ATTRIBUTE_ASSIGNMENTS:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getAttributeAssignments())
					.basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlstorypatternsPackage.STORY_PATTERN_OBJECT__CONSTRAINTS:
			return ((InternalEList<?>) getConstraints()).basicRemove(otherEnd,
					msgs);
		case MlstorypatternsPackage.STORY_PATTERN_OBJECT__ASSIGNMENT_EXPRESSION:
			return basicSetAssignmentExpression(null, msgs);
		case MlstorypatternsPackage.STORY_PATTERN_OBJECT__ATTRIBUTE_ASSIGNMENTS:
			return ((InternalEList<?>) getAttributeAssignments()).basicRemove(
					otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case MlstorypatternsPackage.STORY_PATTERN_OBJECT__BINDING_TYPE:
			return getBindingType();
		case MlstorypatternsPackage.STORY_PATTERN_OBJECT__CONSTRAINTS:
			return getConstraints();
		case MlstorypatternsPackage.STORY_PATTERN_OBJECT__ASSIGNMENT_EXPRESSION:
			return getAssignmentExpression();
		case MlstorypatternsPackage.STORY_PATTERN_OBJECT__ATTRIBUTE_ASSIGNMENTS:
			return getAttributeAssignments();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case MlstorypatternsPackage.STORY_PATTERN_OBJECT__BINDING_TYPE:
			setBindingType((BindingTypeEnum) newValue);
			return;
		case MlstorypatternsPackage.STORY_PATTERN_OBJECT__CONSTRAINTS:
			getConstraints().clear();
			getConstraints().addAll(
					(Collection<? extends MLExpression>) newValue);
			return;
		case MlstorypatternsPackage.STORY_PATTERN_OBJECT__ASSIGNMENT_EXPRESSION:
			setAssignmentExpression((MLExpression) newValue);
			return;
		case MlstorypatternsPackage.STORY_PATTERN_OBJECT__ATTRIBUTE_ASSIGNMENTS:
			getAttributeAssignments().clear();
			getAttributeAssignments().addAll(
					(Collection<? extends AttributeAssignment>) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case MlstorypatternsPackage.STORY_PATTERN_OBJECT__BINDING_TYPE:
			setBindingType(BINDING_TYPE_EDEFAULT);
			return;
		case MlstorypatternsPackage.STORY_PATTERN_OBJECT__CONSTRAINTS:
			getConstraints().clear();
			return;
		case MlstorypatternsPackage.STORY_PATTERN_OBJECT__ASSIGNMENT_EXPRESSION:
			setAssignmentExpression((MLExpression) null);
			return;
		case MlstorypatternsPackage.STORY_PATTERN_OBJECT__ATTRIBUTE_ASSIGNMENTS:
			getAttributeAssignments().clear();
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case MlstorypatternsPackage.STORY_PATTERN_OBJECT__BINDING_TYPE:
			return bindingType != BINDING_TYPE_EDEFAULT;
		case MlstorypatternsPackage.STORY_PATTERN_OBJECT__CONSTRAINTS:
			return constraints != null && !constraints.isEmpty();
		case MlstorypatternsPackage.STORY_PATTERN_OBJECT__ASSIGNMENT_EXPRESSION:
			return assignmentExpression != null;
		case MlstorypatternsPackage.STORY_PATTERN_OBJECT__ATTRIBUTE_ASSIGNMENTS:
			return attributeAssignments != null
					&& !attributeAssignments.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (bindingType: ");
		result.append(bindingType);
		result.append(')');
		return result.toString();
	}

} // StoryPatternObjectImpl
